import java.io.*;

class DemoDataInputStream{
   
   public static void main(String[] args){
                 
      String s = "Esta es una demostracion de uso de DataInputStream";
      
      // Obtenemos una representacion en forma de bytes de esta cadena
      // Cada caracter esta representado por 1 byte
      byte[] bytes2 = s.getBytes();
      
      // Ahora creamos un array de bytes el doble de longitud
      byte[] bytes = new byte[2*s.length()];
      
      // Cada byte que se obtuvo con getBytes se convierte en dos
      // el primero se pone al cero y el segundo se deja con el 
      // valor que se obtuvo con getBytes
      int cont=0;
      for (int i=0;i<2*s.length();i=i+2){
         bytes[i]=0;
         bytes[i+1]=bytes2[cont];
         cont++;
      }
      
      // A partir del array de bytes se obtiene un ByteArrayInputStream
      // a partir de este un BufferedInputStream y a partir de este un 
      // DataInputStream     
      DataInputStream in = new DataInputStream(
           new BufferedInputStream(new ByteArrayInputStream(bytes)));
      
      
      // Si suponemos que no conocemos la longitud la estructura del bucle
      // es la siguiente
      try{
         while (true){
            System.out.print(in.readChar());
         }
      }catch(EOFException e){ // Cuando no hayan mas datos se lanzara esta excepcion
         System.out.println();
         System.out.println("Final de lectura");
      }catch(IOException e){
         System.out.println("Error de lectura");
      }
      
   }
}   
