import java.io.*;

class Productor extends Thread{
   private PipedWriter out;
   private String texto;
   
   Productor(PipedWriter p, String txt){
      out = p;
      texto = txt;
   }
   
   public void run(){
      try{
         
         StringReader sr = new StringReader(texto);
         int c;
         while ((c=sr.read())!=-1)
            out.write(c);
         out.flush();
         out.close();
      }catch(IOException e){
         System.out.println("Error de escritura");
      }

   }
}

class Consumidor extends Thread{
   private PipedReader in;
   private int dif;
   
   Consumidor(PipedReader p,int d){
      in = p;
      dif = d;
   }
   
   public void run(){
      int c;
      try{
         while ((c = in.read())!=-1)
            System.out.print((char)(c+dif));
      }catch(IOException e){
         System.out.println("Error de lectura");
      }
   }
}

class DemoPipes{
   
   public static void main(String[] args){    
      try{
         PipedWriter pw = new PipedWriter();
         PipedReader pr = new PipedReader(pw);
         Productor prod = new Productor(pw,"Texto a enviar al consumidor");
         Consumidor cons = new Consumidor(pr,Integer.parseInt(args[0]));
         prod.start();
         cons.start();
      
        try{
            prod.join();
            cons.join();
         }catch(InterruptedException e){}
      
         System.out.println("\nHilos finalizados");
      }catch(IOException e){}
      
      
         
         
   }
}