
import java.io.*;


class MayusculasWriter extends FilterWriter{
   
   public MayusculasWriter(Writer w){
      super(w);
   }
   
   public void write(int c) throws IOException{
      char car = (char)c;
      car = Character.toUpperCase(car);
      super.write((int)car); 
   }
   
   public void write(String s, int comienzo, int fin) throws IOException{
      for (int i=0; i<s.length(); i++)
         write( (int) s.charAt(i));
   }
   
   public void write(char[] cbuf, int off, int len) throws IOException{
      for (int i=off; i<len; i++)
         write( (int) cbuf[i]);   
   } 
}


class DemoFilterWriter{
   public static void main(String[] args){
      try{
      
         Writer bw = new MayusculasWriter(new BufferedWriter(
            new FileWriter("mayusculas.txt")));
      
      
         BufferedReader br = new BufferedReader(
            new FileReader(args[0]));
                
         String cad="";
         
         while ( (cad=br.readLine())!=null)
            bw.write(cad + "\n");
                  
         br.close();
         
         bw.flush();
         bw.close();
         
      }catch(IOException e){
         System.out.println("Error de Entrada / Salida");
      } 
      
   }
}