import java.io.*;
import java.util.*;

/** Clase que representa un punto 2d*/
class Punto implements Serializable{
   private int x;
   private int y;
   
   Punto(int cx, int cy){
      System.out.println("Creando el punto (" + cx + ", " + cy + ")");
      x = cx;
      y = cy;
   }
   
   public int getX(){
      return x;
   }
   
   public int getY(){
      return y;
   }
} 

class ListaPuntos implements Serializable{
   private LinkedList lista = new LinkedList();
   
   ListaPuntos(int nPuntos){
      System.out.println("Constructor de ListaPuntos");
      int x,y;
      
      for (int i=0; i<nPuntos; i++){
         x = (int) (Math.random()*10);
         y = (int) (Math.random()*10);
         lista.add(new Punto(x,y));
      }
   }
   
   public void muestraPuntos(){
      ListIterator li = lista.listIterator(0);
      Punto p;
      
      while (li.hasNext()){
         p=(Punto)li.next();  
         System.out.println("x = " + p.getX() + ", y = " + p.getY());
      }
   }
}


public class DemoSerializacion{
   public static void main(String[] args){
      ListaPuntos s = new ListaPuntos(5);
      
      try{
         ObjectOutputStream salida = new ObjectOutputStream( 
            new FileOutputStream("objeto.bin"));
         
         System.out.println("Antes");
         salida.writeObject(s);
         System.out.println("Despues");
         
         salida.close();
         
         ObjectInputStream entrada = new ObjectInputStream(
            new FileInputStream("objeto.bin"));
         
         ListaPuntos lp = (ListaPuntos)entrada.readObject();
         
         entrada.close();
         
         lp.muestraPuntos();
      }catch(FileNotFoundException fnfe){ System.out.println("Error E/S");
      }catch(IOException ioe){ System.out.println("Error E/S");
      }catch(ClassNotFoundException ioe){ System.out.println("Clase no encontrada");
      }     
      
      
   }
}
      