import java.io.*;
import java.util.*;


class Usuario implements Externalizable{
   private String usuario;
   private String password;
   
   public Usuario(){
      System.out.println("Creando usuario vacio");
   }
   
   Usuario(String u, String p){
      System.out.println("Creando Usuario (" + u + ", " + p + ")");
      usuario = u;
      password = p;
   }
   
   public void writeExternal(ObjectOutput out)
      throws IOException {
      System.out.println("Usuario.writeExternal");
      // Explicitamente indicamos cuales son los atributos a almacenar
      out.writeObject(usuario);
   }

   public void readExternal(ObjectInput in)
         throws IOException, ClassNotFoundException {
      System.out.println("Usuario.readExternal");
      // Explicitamente indicamos cuales son los atributos a recuperar
      usuario = (String)in.readObject();
   }
   
   
   public void muestra(){
      String cad="Usuario: " + usuario + "   Password: ";
      if (password == null)
         cad = cad + "No disponible";
      else
         cad = cad + password;
      System.out.println(cad);
   }
   
} 

class ListaUsuarios implements Serializable{
   private LinkedList lista = new LinkedList();
   int valor;
   
   ListaUsuarios(String[] usuarios, String[] passwords){
      
      for (int i=0; i<usuarios.length; i++)
         lista.add(new Usuario(usuarios[i],passwords[i]));
   }
   
   public void muestraUsuarios(){
      ListIterator li = lista.listIterator(0);
      Usuario u;
      
      while (li.hasNext()){
         u=(Usuario)li.next();  
         u.muestra();
      }
   }
}


class GuardaExternalizable{
   public static void main(String[] args)
         throws IOException, ClassNotFoundException {
      
      System.out.println("Creando el objeto");
      
      String[] usuarios={"A","B","C"};
      String[] passwords={"1","2","3"};
      
      ListaUsuarios lp = new ListaUsuarios(usuarios,passwords);
      
      System.out.println("\nAlmacenando objeto");   
      ObjectOutputStream o =
         new ObjectOutputStream(
            new FileOutputStream("objetos.out"));
            
      o.writeObject(lp);
      o.close();
   }
}


class LeeExternalizable{
   public static void main(String[] args)
         throws IOException, ClassNotFoundException {
      ListaUsuarios lp;
      
      System.out.println("\nRecuperando objeto");
      ObjectInputStream in =
         new ObjectInputStream(
            new FileInputStream("objetos.out"));
      lp = (ListaUsuarios)in.readObject();
      lp.muestraUsuarios();
   }
}
